import contextlib
import unittest
import io
import unittest.mock
from unittest import TextTestRunner
import re

class MainTest(unittest.TestCase):

    def test_answer(self):

        capturedOutput = io.StringIO()                 
        sys.stdout = capturedOutput                     
        main()
        sys.stdout = sys.__stdout__ 
        output = list(capturedOutput.getvalue().strip().split('\n'))
        if output[-1] == "":
            output.pop()
        
        checkQuery = [
            "if the winner is male, my guess is he's from Norway; probability 54.23%",
            "if the winner is female, my guess is she's from Iceland; probability 44.84%"
        ]

        checkBool = True
        for n in output:
            if n not in checkQuery:
                checkBool = False
            else:
                checkQuery.remove(n)

        if len(checkQuery) > 0:
            checkBool = False

        r = re.compile(r"if the winner is (male|female), my guess is (he's|she's) from (Denmark|Finland|Iceland|Norway|Sweden); probability \d+\.\d{2}%")

        isFormatCorrect = all(r.match(line) for line in output)
        self.assertTrue(isFormatCorrect, "The output format is incorrect. Please take a look at the example output.")

        self.assertTrue(checkBool, "Incorrect answer. Please check your code.")

test_suite = unittest.TestLoader().loadTestsFromTestCase(MainTest)
with io.StringIO() as buf:
    # run the tests
    with contextlib.redirect_stdout(buf):
        TextTestRunner(stream=buf).run(test_suite)
    # process (in this case: print) the results
    printTest(buf.getvalue())