import unittest, sys
import io
import unittest.mock
import re

from tmc import points

from tmc.utils import load, get_out

main = load('src.main', 'main')

class MainTest(unittest.TestCase):
   
    @points('2-2')
    def test_answer(self):
        main()
        output = list(get_out().strip().split("\n"))
        if output[-1] == "":
            output.pop()
        
        checkQuery = [
            "if the winner is male, my guess is he's from Norway; probability 54.23%",
            "if the winner is female, my guess is she's from Iceland; probability 44.84%"
        ]

        checkBool = True
        for n in output:
            if n not in checkQuery:
                checkBool = False
            else:
                checkQuery.remove(n)

        if len(checkQuery) > 0:
            checkBool = False

        r = re.compile(r"if the winner is (male|female), my guess is (he's|she's) from (Denmark|Finland|Iceland|Norway|Sweden); probability \d+\.\d{2}%")

        isFormatCorrect = all(r.match(line) for line in output)
        self.assertTrue(isFormatCorrect, "The output format is incorrect. Please take a look at the example output.")


        self.assertTrue(checkBool, "Incorrect answer. Please check your code.")
          
if __name__ == '__main__':
    unittest.main()
